package cv09.test;

import java.io.*;
import java.util.*;

/**
 * @author Karel Cemus
 */
public class Main {

    private static final Map<Integer, Vehicle> vehicles = new HashMap<>();

    public static void main( String[] args ) throws IOException, ClassNotFoundException {

        System.out.println( "Vitejte v registru aut. Cekam na vstup." );
        doCommands();
    }

    public static void doCommands() throws IOException, ClassNotFoundException {

        Scanner input = new Scanner( System.in );

        while ( input.hasNext() ) {

            String command = input.next();

            switch ( command ) {

                case "EXIT":
                    input.close();
                    return;
                case "NEW":
                    int year = input.nextInt();
                    int price = input.nextInt();
                    int seats = input.nextInt();
                    String name = input.next();
                    Vehicle vehicle = new Automobile( name, price, year, seats );
                    vehicles.put( vehicle.getId(), vehicle );
                    System.out.println( vehicle.getId() );
                    break;
                case "SELL":
                    int id = input.nextInt();
                    if ( !vehicles.containsKey( id ) ) System.out.println( "Vozidlo neni v DB." );
                    else if ( vehicles.get( id ).isSold() ) System.out.println( "Vozidlo je jiz prodano." );
                    else {
                        vehicles.get( id ).sell();
                        System.out.println( "OK" );
                    }
                    break;
                case "LIST":
                    List<Vehicle> sorted = new ArrayList<>( vehicles.values() );
                    Collections.sort( sorted );
                    for ( Vehicle item : sorted ) System.out.println( item );
                    System.out.println( "OK" );
                    break;
                case "SAVE":
                    ObjectOutputStream os = new ObjectOutputStream( new FileOutputStream( "database.db" ) );
                    // ulozime informaci o nextu
                    os.writeInt( Vehicle.getNext() );
                    // ulozime pocet vozidel, ktere budeme zapisovat
                    os.writeInt( vehicles.size() );
                    // zapiseme vozidla
                    for ( Vehicle item : vehicles.values() ) os.writeObject( item );
                    os.close();
                    System.out.println( "OK" );
                    break;
                case "LOAD":
                    ObjectInputStream is = new ObjectInputStream( new FileInputStream( "database.db" ) );
                    // ziskame next
                    Vehicle.setNext( is.readInt() );
                    // zjistime kolik vozidel je v souboru
                    int count = is.readInt();
                    for ( int i = 0; i < count; i++ ) {
                        Vehicle loaded = ( Vehicle ) is.readObject();
                        vehicles.put( loaded.getId(), loaded );
                    }
                    is.close();
                    System.out.println( "OK" );
                    break;
                default:
                    System.out.println( "Prikaz nerozpoznan" );
            }

        }

    }
}
